Foreman - Bug #33270

libvirt VMs showing "unknown power state" and no Console access
08/17/2021 10:58 AM - lan Shore
Pull request:

Description

After upgrading from Foreman 2.3 to 2.4.1, all VMs managed by libvirt are showing "unknown power state". The button for Console
access has also gone missing.

Foreman log indicates an issue with an undefined method:

Backtrace for 'undefined method "allocation' for nil:NilClass' error (ActionView::Template::Error): undefined method “allocation' for
nil:NilClass

4ccdcal8 | /usr/share/foreman/app/views/compute_resources_vms/show/_libvirt.html.erb:46:in “block in
app_views_compute_resources_vms_show_libvirt_html_erb__ 1095817749888559541_69835413092660'

Also if | select a VM by going to Compute Resources and selecting the VM after selecting its host, | am greeted with the message:

Oops, we're sorry but something went wrong undefined method “allocation’ for nil:NilClass

| attach the foreman-rake errors:fetch_log for that here.

History

#1 - 08/18/2021 10:04 AM - Lukas Zapletal
- Category set to Compute resources - libvirt

- Triaged changed from No to Yes

Looks like a regression on fog-libvirt between 0.7 and 0.8 or newer:

https://github.com/fog/fog-libvirt/commits/master?after=b6a6161583b81bac4c1fd4b822305¢369ba82e78+34&branch=master

| have a suspicion on https://github.com/fog/fog-libvirt/pull/75

Can you show me the full backtrace? You can reach me as Izap on our IRC.

#2 - 08/18/2021 10:51 AM - Lukas Zapletal

| see the attachment now, well it did not help. Not sure what is wrong at the moment.

#3 - 08/18/2021 12:46 PM - lan Shore
- File production.log.txt added

- Category deleted (Compute resources - libvirt)
| set debug logging on, restarted httpd, then viewed a VM from the Hosts page. | attach the resulting log file, and hope it is of some use.
#4 - 08/18/2021 01:26 PM - Lukas Zapletal

Thanks, but the root cause is buried down the stack somewhere in the fog/fog-libvirt library. Libvirt call "volumes" returns list of associated data
volumes but it appears to return an array with nil value in it.

Can you tell me how do | reproduce this bug? What's special about these VMs that libvirt fog library returns nil? Can you share libvirt XML of the VM
that triggers the error?

#5 - 08/18/2021 01:45 PM - lan Shore
- File test1.xml.txt added

All the VM hosts display the same "Unknown power state" message. We have 7 VM servers and 25 VMs, built on iISCSi LUNs managed by a NetApp
server. | attach the XML dump from the VM mentioned in the previous log file.

Thanks for your help in this.

#6 - 08/18/2021 03:01 PM - Lukas Zapletal

- Status changed from New to Rejected

| have some bad news for you, for-libvirt only supports file-based storage domain (the default one - directory with files). | am not sure how you created
this VM, but this could not be through Foreman/fog library.

| filed a patch into the library to skip volumes which are not file-based to prevent the nil pointer exception, but that's all | can do for you.

https://github.com/fog/fog-libvirt/pull/105

#7 - 08/18/2021 03:52 PM - lan Shore

Okay, thanks. I'll give it a try tomorrow. Most of the VMs were built before we ever started using Foreman, and we continue to build them the same
way, outside of Foreman.

Files

62f033ad.txt 19.5 KB 08/17/2021 lan Shore
production.log.txt 123 KB 08/18/2021 lan Shore
test1.xml.txt 4.83 KB 08/18/2021 lan Shore
